
var renderClass = "jp.ngt.rtm.render.VehiclePartsRenderer";
importPackage(Packages.org.lwjgl.opengl);
importPackage(Packages.jp.ngt.rtm.render);
importPackage(Packages.jp.ngt.ngtlib.math);
importPackage(Packages.jp.ngt.rtm)
importPackage(Packages.jp.ngt.rtm.entity.train.util);
importPackage(Packages.jp.ngt.ngtlib.io);
importPackage(Packages.jp.ngt.rtm.entity.vehicle);
importPackage(Packages.jp.ngt.ngtlib.util);
importPackage(Packages.jp.ngt.ngtlib.renderer);
//データ保存処理(グローバル関数)
var LocalData = new java.util.HashMap();

//=== オブジェクト定義 ===
function init(par1, par2) {
    //車体
    body = renderer.registerParts(new Parts("body", "body-s", "parts", "parts-s", "No", "cabin", "int"));//車体

    //灯具類
    F_Fon = renderer.registerParts(new Parts("Flight_Fon"));//前方前照灯点灯
    F_Fof = renderer.registerParts(new Parts("Flight_Fof"));//前方前照灯消灯
    F_Bon = renderer.registerParts(new Parts("Flight_Bon"));//前方尾灯点灯
    F_Bof = renderer.registerParts(new Parts("Flight_Bof"));//前方尾灯消灯
    F_ire = renderer.registerParts(new Parts("Flight_ire"));//前方入換灯点灯

    B_Fon = renderer.registerParts(new Parts("Blight_Fon"));//後方前照灯点灯
    B_Fof = renderer.registerParts(new Parts("Blight_Fof"));//後方前照灯消灯
    B_Bon = renderer.registerParts(new Parts("Blight_Bon"));//後方尾灯点灯
    B_Bof = renderer.registerParts(new Parts("Blight_Bof"));//後方尾灯消灯
    B_ire = renderer.registerParts(new Parts("Blight_ire"));//後方入換灯点灯


}

//===== バージョン取得 =====
function MCVersionChecker() {
    var varsion = RTMCore.VERSION;
    if (varsion.indexOf("1.7.10") >= 0) return "1.7.10";
    else if (varsion.indexOf("2.0") >= 0) return "1.8.9";
    else if (varsion.indexOf("2.1") >= 0) return "1.9.4";
    else if (varsion.indexOf("2.2") >= 0) return "1.10.2";
    else if (varsion.indexOf("2.4") >= 0) return "1.12.2";
    else return "unknown";
}

//##### 号車取得 ####################
function isMiddleCar(entity) {//trueなら中間車、falseなら先頭車/後尾車
    var formation = entity.getFormation();//formation型
    if (formation == null) {//formationが取得できないときの処理
        return false;
    }
    var current = formation.getEntry(entity).entryId + 1;//この車両の号車を取得。0から数えるため+1する
    var max = formation.size();//連結してる両数を返す
    if (current == 1 || current == max) {//この車両が先頭or最後尾なら
        return false;
    }
    else {//そうでない(つまり中間)なら
        return true;
    }
}

//##### 両数取得 ####################
function isCarSize(entity) {
    var formation = entity.getFormation();//formation型
    if (formation == null) {//formationが取得できないときの処理
        return 1;
    }
    var max = formation.size();//連結してる両数を返す
    return max;
}

//##### 隣接車両取得 ####################
function isFrontNextCar(entity) {//trueなら車両前方に、falseなら車両後方に車両あり※先頭車でのみ実行
    var frontNext = entity.getConnectedTrain(0);
    if (frontNext == null) {//前方に隣接車の情報が取得できない≒前方に隣接車なし＝後方に隣接車あり
        return false;
    } else {
        return true;
    }
}

//##### render ####################
function render(entity, pass, par3) {
    GL11.glPushMatrix();

    //通常描画
    if (pass == 0) {
        body.render(renderer);
        render_light(entity);
    }

    //半透明描画
    if (pass == 1) {
    }

    //発光部描画
    if (pass > 1) {
        body.render(renderer);
        render_light(entity);
    }

    GL11.glPopMatrix();
}

//##### render_ライト ####################
function render_light(entity) {

    var varsion = MCVersionChecker();
    var st11 = 0; //方向幕の一番上から普通幕の終わりまでのコマ数

    if (entity != null) {
        var form = isMiddleCar(entity);
        var Fnext = isFrontNextCar(entity);
        var max = isCarSize(entity);
    }



    if (entity != null) {
        if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
            var st0 = entity.getTrainStateData(0); //進行方向
            var st11 = entity.getTrainStateData(11); //車内灯
        } else {
            var st0 = entity.getVehicleState(TrainState.getStateType(0)); //進行方向
            var st11 = entity.getVehicleState(TrainState.getStateType(11)); //チャンクローダー
        }
    }

    if (max > 1) {//単行でないとき
        if (form == false) {//編成両端であるとき
            if (Fnext == false) {//自車後方にほかの車両があるとき
                if (st0 == 0) {//前方に進むとき(=進行方向最前)
                    GL11.glPushMatrix();

                    F_Fon.render(renderer);
                    F_Bof.render(renderer);
                    B_Fof.render(renderer);
                    B_Bof.render(renderer);


                    GL11.glPopMatrix();
                } else {//後方に進むとき(=進行方向最後)
                    GL11.glPushMatrix();

                    F_Fof.render(renderer);
                    F_Bon.render(renderer);
                    B_Fof.render(renderer);
                    B_Bof.render(renderer);

                    GL11.glPopMatrix();
                }
            } else {//自車前方にほかの車両があるとき
                if (st0 == 0) {//前方に進むとき(=進行方向最後)
                    GL11.glPushMatrix();

                    F_Fof.render(renderer);
                    F_Bof.render(renderer);
                    B_Fof.render(renderer);
                    B_Bon.render(renderer);


                    GL11.glPopMatrix();
                } else {//後方に進むとき(=進行方向最前)
                    GL11.glPushMatrix();

                    F_Fof.render(renderer);
                    F_Bof.render(renderer);
                    B_Fon.render(renderer);
                    B_Bof.render(renderer);


                    GL11.glPopMatrix();
                }
            }
        } else {//編成中間であるとき
            GL11.glPushMatrix();

            F_Fof.render(renderer);
            F_Bof.render(renderer);
            B_Fof.render(renderer);
            B_Bof.render(renderer);


            GL11.glPopMatrix();
        }
    } else {//単行であるとき
        if (st0 == 0) {//前方に進むとき
            GL11.glPushMatrix();

            F_Fon.render(renderer);
            F_Bof.render(renderer);
            B_Fof.render(renderer);

            if (st11 == 1) {//チャンクローダー1で入換灯
                B_ire.render(renderer);
            } else {//それ以外
                B_Bon.render(renderer);
            }

            GL11.glPopMatrix();
        } else {//後方に進むとき
            GL11.glPushMatrix();

            F_Fof.render(renderer);
            B_Fon.render(renderer);
            B_Bof.render(renderer);

            if (st11 == 1) {//チャンクローダー1で入換灯
                F_ire.render(renderer);
            } else {//それ以外
                F_Bon.render(renderer);
            }

            GL11.glPopMatrix();
        }
    }

}